/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.features.script;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.EqualsAndHashCode;

@AllArgsConstructor
@Builder
@EqualsAndHashCode
public class Hotkey {

    private final int charcode;

    private final boolean ctrl;
    private final boolean shift;
    private final boolean alt;
    private final boolean meta;

    public static Hotkey fromString(String string) {
        String[] parts = string.split("\\+");
        HotkeyBuilder builder = Hotkey.builder();

        for (String part : parts) {
            switch (part.toLowerCase()) {
                case "ctrl":
                    builder.ctrl(true);
                    break;
                case "shift":
                    builder.shift(true);
                    break;
                case "alt":
                    builder.alt(true);
                    break;
                case "meta":
                    builder.meta(true);
                    break;
                default:
                    if (part.length() == 1) {
                        builder.charcode(Character.toLowerCase(part.charAt(0)));
                    } else {
                        throw new IllegalArgumentException("Invalid hotkey: " + string);
                    }
            }
        }

        return builder.build();
    }

    public static Hotkey fromChar(int c, int mods) {
        return Hotkey.builder()
                .charcode(Character.toLowerCase(c))
                .shift((mods & 1) != 0)
                .ctrl((mods & 2) != 0)
                .alt((mods & 4) != 0)
                .meta((mods & 8) != 0)
                .build();
    }
}
